unit DockMemoForm;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, ExtCtrls,
  BaseDockForm, StdCtrls, ActnList, Menus;

const
  Title_EN = 'Memo';
  Title_JA = '';

type
  TDockableMemoForm = class(TBaseDockableForm)
    InfoPanel: TPanel;
    mmMemo: TMemo;
    procedure mmMemoKeyPress(Sender: TObject; var Key: Char);
    procedure mmMemoEnter(Sender: TObject);
    procedure mmMemoExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  public
    class procedure RemoveDockMemoForm;
    class procedure ShowDockMemoForm;
    class procedure CreateDockMemoForm;
  end;

var
  FormInstance: TBaseDockableForm = nil;

implementation

{$R *.dfm}

{ TDockableMemoForm }

class procedure TDockableMemoForm.CreateDockMemoForm;
begin
  if not Assigned(FormInstance) then
    CreateDockableForm(FormInstance, TDockableMemoForm);
end;

class procedure TDockableMemoForm.ShowDockMemoForm;
begin
  CreateDockMemoForm;
  ShowDockableForm(FormInstance);
end;

procedure EnableShortcuts(AValue: Boolean);
  procedure Apply(const Name, ShortCut: string);
  var
    action: TAction;
  begin
    action := TAction(Application.MainForm.FindComponent(Name));
    if action = nil then
      Exit;
    if AValue then
      action.ShortCut := TextToShortCut(ShortCut)
    else
      action.ShortCut := scNone;
  end;
begin
  Apply('EditUndoCommand'     , 'Ctrl+Z'      );
  Apply('EditRedoCommand'     , 'Shift+Ctrl+Z');
  Apply('EditCutCommand'      , 'Ctrl+X'      );
  Apply('EditCopyCommand'     , 'Ctrl+C'      );
  Apply('EditPasteCommand'    , 'Ctrl+V'      );
  Apply('EditSelectAllCommand', 'Ctrl+A'      );
end;

procedure TDockableMemoForm.FormCreate(Sender: TObject);
begin
  inherited;
  {$IF CompilerVersion >= 21.0}
  if not SameText(PreferredUILanguages, 'JA') then
    Caption := Title_EN
  else
  {$IFEND}
    Caption := Title_JA;
end;

procedure TDockableMemoForm.mmMemoEnter(Sender: TObject);
begin
  inherited;
  EnableShortcuts(False);
end;

procedure TDockableMemoForm.mmMemoExit(Sender: TObject);
begin
  EnableShortcuts(True);
  inherited;
end;

procedure TDockableMemoForm.mmMemoKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = ^A then
    begin
      mmMemo.SelectAll;
      Key := #0;
    end;
end;

class procedure TDockableMemoForm.RemoveDockMemoForm;
begin
  FreeDockableForm(FormInstance);
end;

end.
